!  File: ov12.mod
!
!       Obligatorisk oeving i Operasjonsanalyse 2
!
!       Levert av
!
!               Knut Fostad
!               Stig Are Henstein
!               Per Ola Sneve
!
!
!       Xpressmodell for aa finne minste antall
!       NOR-porter for aa bygge en gitt
!       funksjon.
!
!       Leser inn maks antall NOR-porter, antall inganger
!       logisk sluttverdi og alle kombinasjoner for inngangene
!
!
MODEL   NORGATES
!
!
TABLES
!
 DIMM(3)
!
!
DISKDATA
!
 DIMM(1) = ov12.dim
!
LET IMAX = DIMM(1)                      !Maks antall porter
LET NMAX = DIMM(2)                      !Antall innganger
LET LMAX = DIMM(3)                      !Antall linjer i logisk tabell
LET ILAV = int(IMAX/2)
!
!
TABLES
!
 ALFA(NMAX,LMAX)                        !Gir inputverdi fra Input n linje l
 BETA(LMAX)                             !Outputverdi fra den endelige
!                                       sloeyfa med kombinasjon gitt i
!                                       linje l (fra tabell beta)
!
DISKDATA
!
  ALFA(1,1) = ov12.log
  BETA(1)   = ov12.end
!
!
!
!
!
!
VARIABLES
!
 port(i=1:IMAX)                 !Indikerer om port i eksisterer
 input(i=1:IMAX,n=1:NMAX)       !Indikerer om Input n er en
!                                inngang til port i
 x(i=1:IMAX,l=1:LMAX)           !Logisk flyt i NOR-gate sloeyfa
!
!
!
!
CONSTRAINTS
!
!
!       Minimer maalfunksjon
!
 MINOBJ:               &
		sum(i=1:IMAX)port(i)    $
!
!
!       En port kan bare ha en inngang om den eksisterer
!
 Eksists(i=1:IMAX,n=1:NMAX):                    &
		port(i) - input(i,n) > 0
!
!
!       2 innganger pr port
!
 Inngang(i=1:ILAV):             &
		port(2*i) + port(2*i+1) + sum(n=1:NMAX)input(i,n) < 2
!
!
!       Logisk funksjon
!
 Log1(i=1:ILAV,l=1:LMAX):       &
		x(2*i,  l) + x(i,l) < 1
!
 Log2(i=1:ILAV,l=1:LMAX):       &
		x(2*i+1,l) + x(i,l) < 1
!
 Log3(n=1:NMAX,l=1:LMAX,i=1:IMAX | ALFA(n,l) .eq. 1):   &
		input(i,n) + x(i,l)<1
!
!
!       Gjoer gjennom sannhetstabellen for alle
!       kombinasjoner av verdier
!
 Log4(i=ILAV+1:IMAX,l=1:LMAX):          &
		sum(n=1:NMAX | ALFA(n,l) .eq. 1 )input(i,n)     +               &
		x(i,l) - port(i) > 0
!
!
 Log5(i=1:ILAV,l=1:LMAX):               &
		sum(n=1:NMAX | ALFA(n,l) .eq. 1) input(i,n)     +               &
		x(2*i,l) + x(2*i+1,l)  +                                &       
		x(i,l)   - port(i) > 0
!
!
!       Sannhetstabell for resultatkonfigurasjonen
!
 Log6(l=1:LMAX):              &
		x(1,l) = BETA(l)
!
 Log7(i=1:IMAX,l=1:LMAX): &
	 port(i) - x(i,l) > 0
!
!
BOUNDS
!
 port(i=1:IMAX)         .BV.            !Indikerer om port i eksisterer
 input(i=1:IMAX,n=1:NMAX)  .BV.          !Indikerer om Input n er en
!                                        inngang til port i
 x(i=1:IMAX,l=1:LMAX)   .BV.
!       
! port(1)=1 
!
!
GENERATE
