!
! Fil distru20.mod
!
! Trenger filen som heter distru20.wk1
!
!       Gir modellen et navn
!
MODEL distru20
!
!
!
!       Definerer tabeller
!
!
TABLES
!
	INDIK(1)
!
DISKDATA
!
	INDIK = distru20.ind !  leser indikator for preferanse, kostnad og problem
!                               1 er kostnad for problem 18,
!                               2 er preferanse for problem 18,
!                               3 er kostnad for problem 19
!
LET IND = INDIK(1)
!
!
TABLES
!
	DIMM(3)         ! dimensjon eller max antall indekser
!                         
!
DISKDATA -l
!
	DIMM = distru20.wk1 (INDEXST)
!
!
LET FMAX = DIMM(1)
LET DMAX = DIMM(2)
LET KMAX = DIMM(3)
!
!
TABLES
!
	MAXPROD(FMAX)		! Maksimalt antall produserte enheter paa bedrift f
!       
	MAXSTR(DMAX)		! Maksimal stroem gjennom et depot d
!
	MAXOK(DMAX)		! Maksimal oekning av depot (12.19)
!       
	OKKOST(DMAX)		! Oekning av kostnad ved depotoekning (12.19)
!
	DKOST(DMAX)             ! positive tall angir kostnad for bruk av depot d
!                       
	DSPAR(DMAX)		! Kostnadsbesparelse ved aa legge ned depot d 
!         
	MAXDEP(1)               ! max antall tillatte depoter
!
	BEHOV(KMAX)		! Kundebehov
!
	FDKOST(FMAX, DMAX)	! Kostnad frakt fabrikk til depot
!
	FKKOST(FMAX, KMAX)	! Kostnad frakt fabrikk til kunde
!
	DKKOST(DMAX, KMAX)	! Kostnad frakt depot til kunde
!
	FDPREF(FMAX, DMAX)	! Preferanse frakt fra fabrikk til depot
!
	FKPREF(FMAX, KMAX)	! Preferanse frakt fra fabrikk til kunde
!
	DKPREF(DMAX, KMAX)	! Preferanse frakt fra depot til kunde
!
!
DISKDATA -l
!
! Innlesing av data fra lotusfil distru20.wk1
!
	MAXPROD = distru20.wk1 (MAXKAPF)	! 
!       
	MAXSTR = distru20.wk1 (MAXSTRD)
!
	DKOST = distru20.wk1 (DKOSTD)
!
IF IND < 3	! kjoere modell 12.18 med min kostn eller max pref
ASSIGN
!
	MAXSTR(d=1:DMAX | DKOST(d) .gt. 0) = 0          ! Setter kapasitet i depoter som ikke
							! finnes i problem 18 til 0
!
	MAXOK(d=1:DMAX) = 0				! Konstanter som brukes i 12.19 
							! settes lik 0
!       
	OKKOST(d=1:DMAX) = 0				!		""
!
	DKOST(d=1:DMAX) = 0				!		""
!
	DSPAR(d=1:DMAX) = 0				! 		""
!
!
ELSE	! (IF IND ==3)  kjoere modell 12.19 
!
!
DISKDATA -l
!
	MAXOK = distru20.wk1 (MAXOKD)
!       
	OKKOST = distru20.wk1 (OKKOSTD)
!
	DSPAR = distru20.wk1 (DSPARD)
!
!
!
ENDIF
!
!
ASSIGN
!
	DKOST(d=1:DMAX | DSPAR(d) .gt. 0) = DSPAR(d)    ! Setter sparing ved nedleggelse lik 
!                                                         kostnad ved bruk.
	ANTNULL = SUM(d=1:DMAX | DKOST(d) .eq. 0) 1	! Teller opp antallet depoter som finnes, 
							! og ikke kan legges ned
!
! Innlesing av data fra lotusfil
!
DISKDATA -l
!
	MAXANTD = distru20.wk1 (MAXANTD)        ! max antall tillatte depoter
!
	BEHOV = distru20.wk1 (BEHOVK)
!
	FDKOST = distru20.wk1 (KOSTFD)
!
	FKKOST = distru20.wk1 (KOSTFK)
!
	DKKOST = distru20.wk1 (KOSTDK)
!
!
IF IND == 2	! Velger 12.18 med max pref
!
DISKDATA -l
!
	FDPREF = distru20.wk1 (PREFFD)
!
	FKPREF = distru20.wk1 (PREFFK)
!
	DKPREF = distru20.wk1 (PREFDK)
!
!
ELSE		! enten modell 12.18 min kostn, eller 12.19
!
ASSIGN
!
	FDPREF(f=1:FMAX, d=1:DMAX) = 1          ! ved kostnadoptimering er det ingen preferanser 
!                                               ! og derfor settes preferanser lik 1 som indikerer
	FKPREF(f=1:FMAX, k=1:KMAX) = 1          ! ingen preferanse
!
	DKPREF(d=1:DMAX, k=1:KMAX) = 1  	
ENDIF
!
!       
!
VARIABLES
!
!
! Stroem fra fabrikk til depot, defineres ikke hvis frakt er umulig og depot har null kap
!
 fdstrom(f=1:FMAX, d=1:DMAX | (FDKOST(f, d) .ge. 0) .AND. (MAXSTR(d) .gt. 0))
!
!
!
! Stroem fra fabrikk til kunde, defineres ikke hvis frakt er umulig
! 
 fkstrom(f=1:FMAX, k=1:KMAX | FKKOST(f, k) .ge. 0)
!
!
! Stroem fra depot til kunde, defineres ikke hvis frakt er umulig og depot har null kap
!
 dkstrom(d=1:DMAX, k=1:KMAX | (DKKOST(d, k) .ge. 0) .AND. (MAXSTR(d) .gt. 0))
!
!
! Binaervariabel som avgjoer om depot skal benyttes. 
! Defineres ikke hvis depotet ikke kan nedlegges 
!
 dbruk(d=1:DMAX | DKOST(d) .gt. 0)      
!
!
! Binaervariabel som avgjoer om depotkapasiteten skal oekes
! Defineres ikke hvis depotkapasiteten ikke kan oekes
!
 dokes(d=1:DMAX | MAXOK(d) .gt. 0)
!
!              
!            
CONSTRAINTS    
!
!	Mlfunksjon som minimerer kostnad eller maximerer preferanse
!
!
	MINOBJ:   &
		SUM(f=1:FMAX, d=1:DMAX) FDKOST(f, d) * FDPREF(f, d) * fdstrom(f, d) &
	      + SUM(f=1:FMAX, k=1:KMAX) FKKOST(f, k) * FKPREF(f, k) * fkstrom(f, k) &         
	      + SUM(d=1:DMAX, k=1:KMAX) DKKOST(d, k) * DKPREF(d, k) * dkstrom(d, k) &
	      - SUM(d=1:DMAX) DSPAR(d)              &  ! Spart ved nedleggelse
	      + SUM(d=1:DMAX) DKOST(d) * dbruk(d)   &  ! Kostnad ved bruk
	      + SUM(d=1:DMAX) OKKOST(d) * dokes(d)  $
!
!
!	Kapasitet for fabrikker maa ikke overskrides
!
	KAPFAB(f=1:FMAX):       &
		SUM(d=1:DMAX) fdstrom(f, d) + SUM(k=1:KMAX) fkstrom(f, k) < MAXPROD(f)
!
!
!	Kapasitet for depoter maa ikke overskrives
!
	KAPDEP(d=1:DMAX):     &
		SUM(f=1:FMAX) fdstrom(f, d) < SUM(|DKOST(d)=0) MAXSTR(d) + MAXSTR(d) * dbruk(d) + MAXOK(d) * dokes(d)
!
!
!	Likevektligning for depoter
!
	LIKEVE(d=1:DMAX):     &
		SUM(k=1:KMAX) dkstrom(d, k) - SUM(f=1:FMAX) fdstrom(f, d) = 0
!
!
!	Kundebehov maa dekkes
!
	KUNDEB(k=1:KMAX):     &
		SUM(d=1:DMAX) dkstrom(d, k) + SUM(f=1:FMAX) fkstrom(f, k) > BEHOV(k)
!
!
IF IND == 3  ! Kjoerer modell 12.19
!
!
!	Antall depoter ibruk kan ikke vaere mer enn spesifisert	i modellen
!	
	ANTDEP:         &
		SUM(d=1:DMAX) dbruk(d) < MAXANTD - ANTNULL
!
!
!	Oekning aksepteres ikke for depoter som ikke er  ibruk
!
	DOKLOV(d=1:DMAX | DKOST(d) .gt. 0):      &
		dokes(d) < dbruk(d)
ENDIF
!
!
BOUNDS
!
 
 dbruk(d=1:DMAX) .BV.	! Binaervariabel som avgjoer om depotet  er ibruk
!
 dokes(d=1:DMAX) .BV.	! Binaervariabel som avgjoer om depotet skal oekes
!
!
!
GENERATE
!
IF IND == 2	! Velger modell 12.18 med maksmering av preferanse. Da gir ikke maalfunksjon
!		  ut kostnad og denne maa derfor beregnes etter optimering.
ASSIGN
! 
    KOSTNAD =    SUM(f=1:FMAX, d=1:DMAX) FDKOST(f, d) * fdstrom(f, d) &
		+SUM(f=1:FMAX, k=1:KMAX) FKKOST(f, k) * fkstrom(f, k) &         
		+SUM(d=1:DMAX, k=1:KMAX) DKKOST(d, k) * dkstrom(d, k) 
!
PRINT 
   KOSTNAD
ENDIF

PRINT
! Stroem fra fabrikk til deopt
	fdstrom	
! Stroem fra fabrikk til kunde
	fkstrom
! Stroem fra depot til kunde	
	dkstrom
!
!
!
TABLES
	SKYGF(FMAX)		! Skyggepriser for fabrikkapasitet
	SKYGD(DMAX)		! Skyggepriser for depotkapasitet
!
!
ASSIGN
!
!
	SKYGF(f=1:FMAX) = dual(KAPFAB(f))
!
	SKYGD(d=1:DMAX) = dual(KAPDEP(d))
!
!
!
PRINT
!
!	Skyggepriser for fabrikkapasitet
!
	SKYGF
!
!	Skyggepriser for depotkapasitet
!
	SKYGD
!
!