!
!       Obligatorisk dataoeving i Operasjonsanalyse II
!       Utfoert av Roar Myhre og Aasmund Hoeigaard
!       23.10.96 - 3.11.96
!
MODEL MASKIN
!
!
TABLES
!
!
!
 INDEKS(3)
!
!
DISKDATA
 INDEKS(1) = maskin.ind
!
LET IMAX = INDEKS(1)    ! Indeks for produkttype
LET MMAX = INDEKS(2)    ! Indeks for maskintype
LET TMAX = INDEKS(3)    ! Indeks for tidsperiode        
!
!
!
TABLES
 ETTE(TMAX,IMAX)      ! Etterspoersel av produkt i i periode p
 ANTALL(MMAX)         ! Antall maskiner av type m
 KTID(TMAX,MMAX)      ! Max kjoeretid for maskin m i periode t
 PROFBI(IMAX)         ! Profittbidrag fra produkttype i
 TFOR(MMAX,IMAX)      ! Tidsforbruk av maskin m ved produksjon av prod. i
 LKOS(TMAX,IMAX)      ! Lager kostnad for produkt i i periode t
 VEDL(TMAX,MMAX)      ! Antall maskiner under vedlikehold av type m i periode t
 SLUT(TMAX,IMAX)      ! Krav til sluttlager for produkt i
 LMAX(IMAX)           ! Maks. lagerkapasitet for produkt i
!
!
!
DISKDATA
 ETTE(1,1) = maskin.ett
 ANTALL(1) = maskin.ant
 KTID(1,1) = maskin.max
 PROFBI(1) = maskin.pro
 TFOR(1,1) = maskin.tid
 LKOS(1,1) = maskin.lag
 VEDL(1,1) = maskin.ved
 SLUT(1,1) = maskin.slu
 LMAX(1) = maskin.lma
!
!
!
VARIABLES
 prod(t=1:TMAX,i=1:IMAX)  ! Antall produserte enheter av prod. i i periode t
 lage(t=1:TMAX,i=1:IMAX)  ! Antall enheter av prod. i paa lager i periode t
 salg(t=1:TMAX,i=1:IMAX)  ! Antall enheter av prod. i solgt i periode t
!
!
!
CONSTRAINTS
!
!          Maalfunksjon: profitt = inntekt - lagerkostnader
!
 MAXOBJ: &
        SUM(t=1:TMAX,i=1:IMAX) PROFBI(i)*salg(t,i)    &
 -      SUM(t=1:TMAX,i=1:IMAX) LKOS(t,i)*lage(t,i)   $
!
!      Forbruk av maskintid er mindre eller lik tilgjengelig maskintid
!
 TBEG(t=1:TMAX,m=1:MMAX): &
        SUM(i=1:IMAX) TFOR(m,i)*prod(t,i) < KTID(t,m)*(ANTALL(m) - VEDL(t,m))
!
!
!
 VBAA(t=1:1,i=1:IMAX): &
        prod(t,i) - salg(t,i) &
-       lage(t,i) = SLUT(t,i)
!
!
 VBAB(t=2:(TMAX-1),i=1:IMAX): &
        lage(t-1,i) &
+       prod(t,i) - salg(t,i) &
-       lage(t,i) = SLUT(t,i)
!
!
 VBAC(t=TMAX:TMAX,i=1:IMAX): &
        lage(t-1,i) &
+       prod(t,i) - salg(t,i) = SLUT(t,i)


 BALA(i=1:IMAX): &
        SUM(t=1:TMAX) prod(t,i)  &
 -      SUM(t=1:TMAX) salg(t,i)  &
 -      lage(TMAX,i) = 0
!
!
BOUNDS
!
!      Antall solgte enheter er mindre eller lik etterspoerselen
!
 salg(t=1:TMAX,i=1:IMAX) < ETTE(t,i)
!
!      Antall enheter paa leger er mindre eller lik lagerkapasiteten
!
        lage(t=1:TMAX,i=1:IMAX) < LMAX(i)
!
!
!      Modell er ferdig
!
GENERATE
